/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozwho dynamic portal.
 *
 * The Initial Developer of the Original Code is Andy Edmonds.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Code partially derived from Chris Waterson's post at:
 * http://groups.google.com/groups?threadm=3897C4E1.2957BC6%40netscape.com
 *  Also derived from bookmarks.js, notably the getParentFolder function
 * http://lxr.mozilla.org/seamonkey/source/xpfe/components/bookmarks/resources/bookmarks.js#1151
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

 

var numFolders = 0;
var docHTML = "";
var crumbNames = new Array(1);
var crumbNodes = new Array(1);
var lastFolderName = "";
var lastFolderNode = "";
var loadInProgress = false;
var count = 0;
var thirdLevCount = 0;
var pathLabel = new Array(1);
var pathNode = new Array(1);
var rootNode;
  
function countFolders(node) {
  dump("\n\n counting folders for " + node.Value );
  if (RDFCUtils.IsContainer(Bookmarks, node)) {
    // It's a folder
  try {
      var name = Bookmarks.GetTarget(node, kNC_Name, true);
  } catch(e) { dump("get target failed \n"); }
    RDFC.Init(Bookmarks, node);
    var contents = RDFC.GetElements();
    while (contents.hasMoreElements()) {
      var child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    if(RDFCUtils.IsContainer(Bookmarks, child)) numFolders++;      
  }
 }
 dump(" and found " + numFolders + " \n\n");
}
  
function walk(node, curDepth) {
  var folderTitle = "";
  var child; 
  if(!curDepth) curDepth = 1;
  if (RDFCUtils.IsContainer(Bookmarks, node)) {
   	var name = Bookmarks.GetTarget(node, kNC_Name, true);
   	var description =  Bookmarks.GetTarget(node, kNC_Description,true);
		if(curDepth == 2) {
    	count++;
      lastFolderName = name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      lastFolderNode = node.Value;
      folderTitle = name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
      docHTML += "<div class='topfolder' type='folder' container='true' closed='false'";
      docHTML += " ref='" + node.Value + "' title='" +  folderTitle + "' depth='" +(crumbNames.length+1) + "' " ;
      docHTML += " title='" + escape(description) + "' ";
		docHTML += "><b>" + name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + " "; 
      //(" + RDFC.GetCount() + ")";
      docHTML +="</b> ";
    } else {
      // Write Header For Current Folder
		// GetCount gives bogus numer sometimes.
      if(curDepth == 1) {
        docHTML += "<span id='current' onmousedown='window.location=\"bookmarksfull.html" + window.location.search + "\"'>" ;   
        docHTML += name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + " (" + RDFC.GetCount() + ")";
        docHTML +=" </span><br/>  "; 
      } else {
        docHTML += "<span class='folder' type='folder'  ";
        // dump("== child of " + lastFolderName + " " + lastFolderNode + "\n");
        docHTML += " parentName='" + lastFolderName + "' parentNode='" + lastFolderNode + "' ";
        docHTML += " ref='" + node.Value + "' title='" +  name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value +  "' depth='" +(crumbNames.length+1) + "' >" ;
         docHTML += name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + " ";
        //(" + RDFC.GetCount() + ")";  , 
        // Buggy this generates wildy inaccurate counts. Why?
         docHTML +=" </span>";
       }
     }
     RDFC.Init(Bookmarks, node);
     var contents = RDFC.GetElements();
     while (contents.hasMoreElements()) {
       child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	    if(curDepth < 3) {
	      walk(child,  curDepth+1);  
	    }

     }
   if(curDepth == 2) {
      docHTML += "</div>"
    }      
  }
}
  
function walkMarks(node) {
  if (RDFCUtils.IsContainer(Bookmarks, node)) {
      // It's a folder
    try {
      var name = Bookmarks.GetTarget(node, kNC_Name, true);
    } catch(e) { dump("get target failed \n"); }

      RDFC.Init(Bookmarks, node);
      var contents = RDFC.GetElements();
      while (contents.hasMoreElements()) {
        child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
        currentLevelMarks(child);
      }     
    }
}
  
function currentLevelMarks(node) {
	var anonID;
  if (!RDFCUtils.IsContainer(Bookmarks, node)) {
    // It's a bookmark.
    try {
      docHTML += "<div class='bookmark' type='link' "
			docHTML += " ref='" + node.Value + "' ";
			docHTML += " container='false' closed='false'>";
      docHTML += "<a href='" + Bookmarks.GetTarget(node, kNC_URL, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value+ "' ";
			anonID = node.Value;
			dump(anonID+"\n");
      try {
				docHTML += " title='"  + Bookmarks.GetTarget(node, kNC_Description, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value + "'"
      	
      } catch(e) {
				// no description.
			}
			docHTML += ">";
      docHTML += Bookmarks.GetTarget(node, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value ;
     docHTML += "<a>";
		    docHTML += " <a href='#' onclick='window.openDialog(\"chrome://communicator/content/bookmarks/bm-props.xul\",\"\",\"centerscreen,chrome,dependent,resizable=no\", \""+ anonID+"\");'>...</a>";
 
		 docHTML +="</div>";
		 dump("ID is " + anonID + "\n");
   } catch(e) {dump("err " + e + "\n");}  
  }
}

function buildCrumb(nodeID) {
  mystr = "";
	var title;
  dump("\n\n --- CRUMBS --- " +  pathNode + " " + pathLabel + " crumbs \n\n");
	var newParentID = nodeID; // Storage for current RDF ID
	var node; // storage for RDF object
	
  while(newParentID != "NC:BookmarkRoot" && newParentID != "NC:BookmarksTopRoot" && newParentID != "NC:BookmarksRoot" ) {
		node =  RDF.GetResource(nodeID);
		arcCursor = Bookmarks.ArcLabelsIn(node); 
		newParentID =getParentFolder( node, arcCursor);
		dump("Got parent " + newParentID + "\n");
		node = RDF.GetResource(newParentID);
		title = Bookmarks.GetTarget(node, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value ;
		mystr= "<span type='breadcrumb' ref='" + newParentID + "' class='crumb' depth ='1'>" + title + "</span>  <span class='crumbdivider'>>></span> " + mystr; 
		nodeID = newParentID;

	}  
    document.getElementById("breadcrumb").innerHTML = mystr;
}


function mozwhoInit() {
  dump("\n\n\n|INIT mozwho|\n\n");
  dump("URL: " + location.search + "\n\n");
  // Are we at the root? 
  // Or do we have a target string?
  if(location.search != "") {
    dump("parsing url params " + typeof(parseQueryString("labels")) + "\n")
    var paths = parseQueryString("labels");
    pathLabel = paths.split(",");
    var nodes = parseQueryString("nodes");
    pathNode = nodes.split(",");
   // dump("---label is " + pathLabel + " " + pathLabel.length +" \n---and path is " + pathNode + " " + pathNode.length + "\n");
    node = pathNode[pathNode.length-1];
    buildCrumb(node);
    document.title ="mozwho:  " + paths;
  } else {
    dump("Resetting Path to Root \n")
    path="Home";
    node="NC:BookmarksRoot";;
    pathNode[0] = "NC:BookmarksRoot";
    pathLabel[0] = "Home"; 
  }
  dump("Initing node " + node + "\n");
  node =  RDF.GetResource(node);
	// Need this var for the arc functions
	// rootDS = RDF.GetDataSource("rdf:bookmarks")
  countFolders(node);
  // Write FOlders
  walk(node);

  document.getElementById('folders').innerHTML = docHTML;
  //addListeners();
  docHTML="";
  // Write bookmarks
  walkMarks(node);
  document.getElementById('marks').innerHTML = docHTML;
}




function getParentFolder(thisResource,arcCursor) {
  while(arcCursor.hasMoreElements()) {
		thisArc = arcCursor.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
		if (RDFCUtils.IsOrdinalProperty(thisArc)) {
			//dump("got container arc  " + thisArc.Value + "\n");
			return   Bookmarks.GetSources(thisArc, thisResource, true).getNext().QueryInterface(kRDFRSCIID).Value;
		}
	}
}
